unit Uaspg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, AdvGrid, advsprd, StdCtrls, Spin, ComCtrls, Buttons;

type
  TForm1 = class(TForm)
    AdvSpreadGrid1: TAdvSpreadGrid;
    CheckBox1: TCheckBox;
    SpinEdit1: TSpinEdit;
    Label1: TLabel;
    StatusBar1: TStatusBar;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    procedure AdvSpreadGrid1FormulaError(Sender: TObject; aCol,
      aRow: Integer; S: String);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure AdvSpreadGrid1AutoDeleteRow(Sender: TObject; aRow: Integer);
    procedure AdvSpreadGrid1AutoInsertRow(Sender: TObject; ARow: Integer);
    procedure AdvSpreadGrid1SelectCell(Sender: TObject; ACol,
      ARow: Integer; var CanSelect: Boolean);
    procedure AdvSpreadGrid1GetCellColor(Sender: TObject; ARow,
      ACol: Integer; AState: TGridDrawState; ABrush: TBrush; AFont: TFont);
    procedure AdvSpreadGrid1GetAlignment(Sender: TObject; ARow,
      ACol: Integer; var AAlignment: TAlignment);
    procedure AdvSpreadGrid1GridHint(Sender: TObject; Arow, Acol: Integer;
      var hintstr: String);
    procedure AdvSpreadGrid1CellFormat(Sender: TObject; ACol,
      Arow: Integer; var format: String; var datetype: Boolean);
    procedure AdvSpreadGrid1CalcCustomFunction(sender: TObject;
      var func: String; var param: Double);
    procedure AdvSpreadGrid1IsCustomFunction(sender: TObject;
      var func: String; var match: Boolean);
  private
    { Private declarations }
    selcol,selrow:integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Uhelp;

{$R *.DFM}

procedure TForm1.AdvSpreadGrid1FormulaError(Sender: TObject; aCol,
  aRow: Integer; S: String);
begin
 statusbar1.simpletext:=s;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 advspreadgrid1.AutoSpreadHeaders;
 advspreadgrid1.savefixedcells:=false;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
 advspreadgrid1.clear;
 advspreadgrid1.AutoSpreadHeaders;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
 if opendialog1.execute then         
  begin
   advspreadgrid1.loadfromcsv(opendialog1.filename);
   advspreadgrid1.recalc;
  end; 
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
 if savedialog1.execute then
  advspreadgrid1.savetocsv(savedialog1.filename);
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
 advspreadgrid1.showformula:=checkbox1.checked;
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
 advspreadgrid1.cellformat:='%.'+inttostr(spinedit1.value)+'f';
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
 help.show;
end;

procedure TForm1.AdvSpreadGrid1AutoDeleteRow(Sender: TObject;
  aRow: Integer);
begin
 advspreadgrid1.AutoSpreadHeaders;
end;

procedure TForm1.AdvSpreadGrid1AutoInsertRow(Sender: TObject;
  ARow: Integer);
begin
 advspreadgrid1.AutoSpreadHeaders;
end;

procedure TForm1.AdvSpreadGrid1SelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
 canselect:=true;

 advspreadgrid1.cells[selcol,0]:=advspreadgrid1.cells[selcol,0];
 advspreadgrid1.cells[0,selrow]:=advspreadgrid1.cells[0,selrow];

 selcol:=acol;
 selrow:=arow;

 advspreadgrid1.cells[selcol,0]:=advspreadgrid1.cells[selcol,0];
 advspreadgrid1.cells[0,selrow]:=advspreadgrid1.cells[0,selrow];
end;

procedure TForm1.AdvSpreadGrid1GetCellColor(Sender: TObject; ARow,
  ACol: Integer; AState: TGridDrawState; ABrush: TBrush; AFont: TFont);
begin
 if ((acol=advspreadgrid1.col) and (arow=0)) or
    ((arow=advspreadgrid1.row) and (acol=0)) then
      begin
       afont.style:=[fsBold];
       afont.color:=clBlue;
      end;
end;

procedure TForm1.AdvSpreadGrid1GetAlignment(Sender: TObject; ARow,
  ACol: Integer; var AAlignment: TAlignment);
begin
 if (acol=0) or (arow=0) then aalignment:=taCenter;
end;

procedure TForm1.AdvSpreadGrid1GridHint(Sender: TObject; Arow,
  Acol: Integer; var hintstr: String);
begin
 hintstr:=advspreadgrid1.Cells[acol,arow];
end;

procedure TForm1.AdvSpreadGrid1CellFormat(Sender: TObject; ACol,
  Arow: Integer; var format: String; var datetype: Boolean);
begin
 datetype:=(acol=7);
 if datetype then format:='ddd dd/mm/yyyy';
end;

procedure TForm1.AdvSpreadGrid1CalcCustomFunction(sender: TObject;
  var func: String; var param: Double);
begin
 if func='BFS' then param:=param*2;
 if func='SELECT' then param:=125;
end;

procedure TForm1.AdvSpreadGrid1IsCustomFunction(sender: TObject;
  var func: String; var match: Boolean);
begin
 match:=pos('BFS',func)=1;
 if match then func:='BFS'
 else
  begin
   match:=pos('SELECT',func)=1;
   if match then func:='SELECT';
  end;

end;

end.
